program define cleandirs
	syntax, [all]
	local dirs ccineq
	local exists : dir . dirs *
	foreach dir of local dirs {
		if `: list dir in exists' {
			cleanup `dir'
		}
	}

	local files ccineq_dta02.do ccineq_dta01.do
	local exists : dir . files *
	foreach file of local files {
		if `:list file in exists' {
			erase `file'
		}
	}
	capture boilerplate, resetdefault
	if "`all'" != "" {
		capture boilerplate, remove(cs1)
	}
	capture boilerplate, remove(cs2)
	if "`all'" != "" {
		capture boilerplate, remove(cs3)
	}
	capture mkproject, remove(pcs)
end

program define cleanup

    local odir = c(pwd)
    capture noisily main `0'
    if _rc {
        qui cd "`odir'"
        exit _rc
    }
    qui cd "`odir'"
end

program define main
    syntax anything(name=dir)
    
    local dir : list clean dir
    mata: fillindir(`"`dir'"')
    qui cd "`dir'"
	
    local dirs: dir "." dirs "*"
    local files: dir "." files "*"
    foreach file of local files {
        erase "`file'"
    }
    foreach subdir of local dirs {
        main `subdir'
    }
    qui cd ..
    rmdir "`dir'"
    
end

mata:
void fillindir(string scalar dir)
{
    if(!pathisabs(dir)) {
        dir = pathresolve(pwd(),dir)
		st_local("dir",dir)
    }
}
end
